#!/bin/bash
#
#       55 - Configure shared folders 
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Unitats compartides \n"
echo "****************************************************"

. /etc/Linkat/linkat-server/Entorn_env

res_code=0
if [ ! -e /srv/exports ];then
	echo -en "S'està creant el directori /srv/exports... \n"
	res=$(mkdir -m 555 /srv/exports 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al crear el directori /srv/exports: $res\n"
		res_code=1
	else
		echo -en "Ok\n"
	fi
else
	echo -en "S'estan establint els permisos del directori d'unitats compartides...\n"
	res=$(chmod 555 /srv/exports 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al establir els permisos del directori /srv/exports: $res\n"
		res_code=1
	else
		echo -en "Ok\n"
	fi
fi

if [ $res_code=0 ];then
	if [ ! -e /srv/exports/S ];then
		echo -en "S'està creant directori /srv/exports/S \n"
		res=$(mkdir -m 6775 /srv/exports/S 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al crear el directori /srv/exports/S ; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/S\n"
			res=$(chown root.Administradors /srv/exports/S 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/S; $res\n"
			else
				echo -en "Ok\n"
			fi
		fi
	else
		echo -en "S'estan establint els permisos al directori /srv/exports/S\n"
		res=$(chown root.Administradors /srv/exports/S 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/S; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/S"
			res=$(chmod 6775 /srv/exports/S 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/S ; $res\n"
			fi
		fi
	fi

	if [ ! -e /srv/exports/T ];then
		echo -en "S'està creant el directori /srv/exports/T\n"
		res=$(mkdir -m 777 /srv/exports/T 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al crear el directori /srv/exports/T ; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/T \n"
			res=$(chown nobody.Administradors /srv/exports/T 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/T; $res\n"
			fi
		fi
	else
		echo -en "S'estan establint els permisos al directori /srv/exports/T\n"
		res=$(chown nobody.Administradors /srv/exports/T 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/T; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/T \n"
			res=$(chmod 777 /srv/exports/T 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/T ; $res\n"
				res_code=1
			fi
		fi
	fi

## P

	if [ ! -e /srv/exports/P ];then
		echo -en "S'està creant el directori /srv/exports/P\n"
		res=$(mkdir -m 6770 /srv/exports/P 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al crear el directori /srv/exports/P ; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/P\n"
			res=$(chown root.Professorat /srv/exports/P 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/P; $res\n"
			fi
		fi
	else
		echo -en "S'estan establint els permisos al directori /srv/exports/P\n"
		res=$(chown root.Professorat /srv/exports/P 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/P; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/P:\n"
			res=$(chmod 6770 /srv/exports/P 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/P ; $res\n"
				res_code=1
			fi
		fi
	fi

## M
	if [ ! -e /srv/exports/M  ];then
		echo -en "S'està creant el directori /srv/exports/M \n"
		res=$(mkdir -m 6770 /srv/exports/M  2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al crear el directori /srv/exports/M  ; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/M \n"
			res=$(chown root.Professorat /srv/exports/M  2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/M ; $res\n"
			fi
		fi
	else
		echo -en "S'estan establint els permisos al directori /srv/exports/M \n"
		res=$(chown root.Professorat /srv/exports/M  2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/M ; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/M :\n"
			res=$(chmod 6770 /srv/exports/M  2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/M  ; $res\n"
				res_code=1
			fi
		fi
	fi



	if [ ! -e /srv/exports/G ];then
		echo -en "S'està creant el directori /srv/exports/G\n"
		res=$(mkdir -m 6770 /srv/exports/G 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "\n\tError:: S'ha produït un error al crear el directori /srv/exports/G ; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/G\n"
			res=$(chown root.Gestio /srv/exports/G 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: S'ha produït un error al canviar els permisos del directori de gestió; $res\n"
			fi
		fi
	else
		echo -en "S'estan establint els permisos al directori de gestió"
		res=$(chown root.Gestio /srv/exports/G 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al canviar els permisos del directori /srv/exports/G; $res\n"
		else
			echo -en "S'estan establint els permisos al directori /srv/exports/G\n"
			res=$(chmod 6770 /srv/exports/G 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "\n\tError:: S'ha produït un error al canviar els permisos del directori de gestió ; $res\n"
				res_code=1
			fi
		fi
	fi
fi


echo -en "\n************Creant els directoris per la PAPERERA*************\n"

if [ ! -e /srv/exports/Paperera ];then
	echo -en "S'està creant el directori Paperera\n"
	res=$(mkdir -m 6775 /srv/exports/Paperera 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "\n\tError:: S'ha produït un error al crear el directori Paperera: $res\n"
	else
		echo -en "S'estan establint els permisos al directori Paperera \n"
		res=$(chown root.Administradors /srv/exports/Paperera 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: S'ha produït un error al canviar els permisos de la Paperera: $res\n"
		fi
	fi
else
	echo -en "S'estan establint els permisos a la Paperera \n"
	res=$(chown root.Administradors /srv/exports/Paperera 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al canviar els permisos de la Paperera: $res\n"
	else
		echo -en "S'estan establint els permisos a la Paperera \n"
		res=$(chmod 6775 /srv/exports/Paperera 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "\n\tError:: S'ha produït un error al canviar els permisos de la Paperera: $res\n"
			res_code=1
		fi
	fi
fi

es=$(mkdir -p /srv/exports/Paperera/{Paperera_Unitat_G,Paperera_Unitat_P,Paperera_Unitat_T,Paperera_Unitat_M} 2>&1)

if [ ! $? -eq 0 ]; then
	echo -en "Error: No s'han creat correctament les carpetes de la paperera: $res\n"
else
	echo -en "Succeed: S'han creat correctament les carpetes de la paperera\n"
fi

echo -en "\n************Configurant els permisos de la PAPERERA*************\n"

res=$(chmod 770 /srv/exports/Paperera/Paperera_Unitat_G 2>&1)
res=$(chmod 770 /srv/exports/Paperera/Paperera_Unitat_P 2>&1)
res=$(chmod 775 /srv/exports/Paperera/Paperera_Unitat_T 2>&1)
res=$(chmod 770 /srv/exports/Paperera/Parepera_Unitat_M 2>&1)

echo -en "\n************Modifiquem propietari de les PAPERERES*************\n"


res=$(chown root:Gestio /srv/exports/Paperera/Paperera_Unitat_G 2>&1)
res=$(chown root:Professorat /srv/exports/Paperera/Paperera_Unitat_P 2>&1)
res=$(chown nobody:Administradors /srv/exports/Paperera/Paperera_Unitat_T 2>&1)
res=$(chown root:Professorat /srv/exports/Paperera/Paperera_Unitat_M 2>&1)


echo -en "Configurem script que esborri els fitxers antics... \n"

res=$(cp $DIR_LINKAT/data/erase_trash.Linkat /etc/cron.weekly/erase_trash 2>&1)
if [ ! $? -eq 0 ]; then
	echo -en "Error:: No s'ha instal·lat el cron-job erase_trash: $res \n"
else
	echo -en "Succeed: Cron-job erase_trash correctament \n"
	res=$(chmod 755 /etc/cron.weekly/erase_trash 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produït un error al establir els permisos de erase_trash: $res\n"
		res_code=1
	else
		echo -en "Succeed: S'han establert els permisos de erase_trash \n"
	fi
fi


echo -en "************ PAPERERA preparada*************\n"



res=$(setfacl -m default:group::rwx /srv/exports/G)
if [ ! $? -eq 0 ]; then
	echo -en "Error:: S'ha produït un error al canviar les acl's del directori de gestió ; $res\n"
else
	echo -en "ACLs de /srv/exports/G modificades correctament\n"
fi

res=$(setfacl -m default:group::rwx /srv/exports/P)
if [ ! $? -eq 0 ]; then
	echo -en "Error:: S'ha produït un error al canviar les acl's del directori de professorat ; $res\n"
else
	echo -en "ACLs de /srv/exports/P modificades correctament\n"
fi

res=$(setfacl -m default:group::rwx /srv/exports/M)
if [ ! $? -eq 0 ]; then
	echo -en "Error:: S'ha produït un error al canviar les acl's del directori multimedia; $res\n"
else
	echo -en "ACLs de /srv/exports/M modificades correctament\n"
fi

## MiniDLNA ACL
res=$(setfacl -m default:user:minidlna:rx -m user:minidlna:rx /srv/exports/M)
if [ ! $? -eq 0 ]; then
        echo -en "Error:: S'ha produït un error al canviar les acl's de minidlna del directori multimedia; $res\n"
else
        echo -en "ACLs minidlna de /srv/exports/M modificades correctament\n"
fi

res=$(setfacl -m default:group::rwx -m default:other::rwx /srv/exports/T)
if [ ! $? -eq 0 ]; then
	echo -en "Error:: S'ha produït un error al canviar les acl's del directori de treball ; $res\n"
else
	echo -en "ACLs de /srv/exports/T modificades correctament\n"
fi

res=$(setfacl -m default:group::rwx /srv/exports/S)
if [ ! $? -eq 0 ]; then
        echo -en "Error:: S'ha produït un error al canviar les acl's del directori de programari; $res\n"
else
	echo -en "ACLs de /srv/exports/S modificades correctament\n"
fi


##### Donem permisos d'escriptura al grup editors ###
res=$(setfacl -m default:group:Editors:rwx -m group:Editors:rwx  /srv/exports/S)
if [ ! $? -eq 0 ]; then
        echo -en "Error:: S'ha produït un error al canviar les acl's del directori de programari; $res\n"
else
	echo -en "ACLs de /srv/exports/S modificades correctament\n"
fi


##Afegit a l'últim script per aplicar correctament les ACL
#echo "Apliquem ACLS a les unitats de la paperera\n"

#res=$(getfacl /srv/exports/G | setfacl --set-file=- /srv/exports/Paperera/Paperera_Unitat_G 2>&1)
#res=$(getfacl /srv/exports/P | setfacl --set-file=- /srv/exports/Paperera/Paperera_Unitat_P 2>&1)
#res=$(getfacl /srv/exports/T | setfacl --set-file=- /srv/exports/Paperera/Paperera_Unitat_T 2>&1)
#res=$(getfacl /srv/exports/M | setfacl --set-file=- /srv/exports/Paperera/Paperera_Unitat_M 2>&1)


