#!/bin/bash
#
# Zenity GUI to setup DNS giving default values.
#

# Functions

check_ip()
{
	echo "$1" | grep -E '^(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])$' > /dev/null 2>&1
	return $?
}

ZENITY=$(which zenity)

# Loop until user chooses right values for DNS configuration.
FI=0
while [ $FI -eq 0 ] ; do
	FI=1
	INFO=$($ZENITY --title="Configuració DNS" --width="500" --height="250" --list --checklist --text="Trieu o modifiqueu els servidors DNS que faran de reenviadors.\nPer modificar una entrada, cliqueu a sobre de la IP que vulgueu modificar i després premeu la tecla espai." --column="" --column="DNS" TRUE ${DNS1} TRUE ${DNS2} FALSE "" --editable --print-column="ALL" --separator=" ")
	if [ $? -ne 0 ] ; then
		FI=0
		$ZENITY --error --text="Si us plau accepteu la configuració." --timeout=20
	else
		if [ -z "$INFO" ] ; then
			FI=0
			$ZENITY --error --text="Si us plau seleccioneu com a mínim un DNS." --timeout=20
		else
			for ip in $INFO ; do
				check_ip $ip
				if [ $? -ne 0 ]; then
					FI=0
					$ZENITY --error --text="L'adreça IP $ip no és correcte, si us plau introduïu-la de nou." --timeout=20
					break
				fi
			done
		fi
	fi
done


echo "export NEW_DNS=$ip" >> $DIR_LINKAT/.entornvarlinkat 




