#!/bin/bash
#
#       65 - Configure JClic server 
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] JClic \n"
echo "****************************************************"

. /etc/Linkat/linkat-server/Entorn_env
. /etc/Linkat/linkat-server/.entornvarlinkat

DIR_JCLIC_JAVA=/usr/share/java/JClic
DIR_JCLIC_JAVA_PROJECTS=/usr/share/java/JClic/projects

if [ ! -e $DIR_JCLIC_JAVA_PROJECTS ];then
		echo -en "Warning:: No hi ha projectes al servidor. En cas que s'hagi instal·lat el paquet jclic-projects, cal tornar-lo a instal·lar\n"
fi


if [ ! -e /srv/exports/S/jclic ];then
	echo -en "Creant directori de jclic al recurs compartit programari (/srv/exports/S/jclic) \n"
	res=$(mkdir -p -m 775 /srv/exports/S/jclic 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error: Hi ha hagut un problema al crear el directori /srv/exports/S/jclic ; $res\n"
		res_code=1
	else
		echo -en "Ok\n"
	fi
fi

 

if [ $res_code=0 ];then
	if [ -e /srv/exports/S/jclic/projects ];then
		res=$(rm -rf /srv/exports/S/jclic/projects 2>&1)
		echo -en "Ja hi havia un repositori de projectes. Esborrant-lo:"
		if [ ! $? -eq 0 ];then
			echo -en "Error:: No s'ha pogut esborrar; $res\n"
		else
			echo -en "Ok\n"
		fi
        fi

	res_code=0
	if [ -e $DIR_JCLIC_JAVA/jclic.cfg ];then
		echo -en "Fent còpia de seguretat de la configuració de projectes de JClic: "
		res=$(mv $DIR_JCLIC_JAVA/jclic.cfg $DIR_JCLIC/backup/jclic.cfg.orig 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error: No s'ha pogut fer una còpia de seguretat de la configuració de client de    reports; $res\n"
		else
			echo -en "Ok\n"
		fi
	fi

	if [ $res_code -eq 0 ];then
		echo -en "Aplicant configuració de projectes de JClic de la Linkat: "
		res=$(cat $DIR_JCLIC/data/jclic.cfg | sed s/__SERVIDOR__/$NOM\.$DOMINI/g > $DIR_JCLIC_JAVA/jclic.cfg 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: No s'ha pogut copiar la configuració de client del servidor d'informes ; $res\n"
			res_code=1
		else
			echo -en "Ok\n"
			echo -en "Establint els permisos de la configuració de JClic: "
			res=$(chmod 664 $DIR_JCLIC_JAVA/jclic.cfg 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error::Error establint els permisos del fitxer de configuració de JClic;$res\n" 
			else
				echo -en "Ok\n"
			fi
		fi
	fi

	if [ $res_code=0 ];then
		echo -en "Copiant projectes al recurs compartit de JClic: "
		res=$(mv $DIR_JCLIC_JAVA_PROJECTS /srv/exports/S/jclic 2>&1 )
		if [ ! $? -eq 0 ];then
			echo -en "Error:: Ha hagut un problema al moure el repositori local de projectes a la unitat compartida; $res\n"
		else
			echo -en "Establint els permisos adequats al directori de projectes de JClic: "
			res=$(chmod -R 775 /srv/exports/S/jclic/projects 2>&1)
			if [ ! $? -eq 0 ];then
				echo -en "Error:: No s'ha pogut canviar els permisos del nou repositori local de projectes, es possible que alguns usuaris no puguin escriure en aquesta; $res\n"
			else
				echo -en "Ok\n"
				res=$(chown -R root.Administradors /srv/exports/S/jclic 2>&1)
				if [ ! $? -eq 0 ];then
					echo -en "Error:: No s'ha pogut canviar els permisos del nou repositori local de projectes, es possible que alguns usuaris no puguin escriure en aquesta; $res\n"
				else
					echo -en "Ok\n"
				fi
			fi
		fi
	fi
fi

 
                
if [ -e /etc/.edu.xtec.properties ];then
	echo -en "Aplicant configuració de JClic per la Linkat: "
	res=$(rm -rf /etc/.edu.xtec.properties 2>&1)
	if  [ ! $? -eq 0 ];then
		echo -en "Warning:: Hi havia un anterior fitxer de configuració i no s'ha pogut esborrar"
	else
		echo -en "Ok\n"
	fi
fi

echo -en "Copiant configuració de JCLic a la Linkat: "
res=$(cp $DIR_JCLIC/data/.edu.xtec.properties /etc/ 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut crear el fitxer de configuració general de JClic"
else
	echo -en "Ok\n"
	echo "Establint els permisos de la configuració de JClic"
	res=$(chmod 664 /etc/.edu.xtec.properties 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error::Error establint els permisos del fitxer de configuració de JClic: $res\n"
	else
		echo -en "Ok\n"
		echo -en "Obtenint idioma del sistema: "
		lang=$(locale | grep "\bLANG\b" | cut -d "=" -f 2 | cut -d "_" -f 1)
		if [ ! $? -eq 0 ];then  
			echo -en "Warning:: no s'ha pogut obtenir l'idioma del sistema, posant el català"
			lang=ca
		else
			echo -en "Ok\n"
			if [ "$lang" == "" ];then
				lang=ca
			fi
			echo -en "Aplicant idioma del sistema al JClic: "
			res=$(echo "language=$lang" >> /etc/.edu.xtec.properties 2>&1)
			if [ ! $? -eq 0 ];then  
				echo -en "Error:: No s'ha pogut configurar l'idioma per defecte del JClic:  $res\n"
			else
				echo -en "Ok\n"
			fi
		fi
	fi
fi



if [ $err_code=0 ];then
	if [ -e  /usr/lib/jvm/java-1.6.0-sun-1.6.0/jre/lib/.edu.xtec.properties ];then
		echo -en "Configurant java per agafar la configuració de JClic: "
		res=$(rm -rf /usr/lib/jvm/java-1.6.0-sun-1.6.0/jre/lib/.edu.xtec.properties 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Warning:: Ja existia un fitxer /usr/lib/jvm/java-1.6.0-sun-1.6.0/jre/lib/.edu.xtec.properties, s'ha intentat esborrar però no s'ha pogut esborrar: $res\n"
		else
			echo -en "Ok\n"
		fi
	fi

	if [ ! -e /etc/.edu.xtec.properties ];then
		echo "Creant enllaç des de directori de java a configuració de JClic \n"
		res=$(ln -s /etc/.edu.xtec.properties /usr/lib/jvm/java-1.7.0-openjdk-i386/jre/lib 2>&1)
		if [ ! $? -eq 0 ];then  
			echo -en "Error:: No s'ha pogut crear el link simbòlic per la configuració de JClic: $res"
		else
			echo -en "Success: Aplicada la configuració per defecte del client JClic\n"
	   	fi
	
	fi

fi


# Icona de JCLic

#res=$(cat $DIR_JCLIC/data/jclicreports.desktop.Linkat | sed s/__SERVIDOR__/$NOM\.$DOMINI/g > /usr/share/applications/jclicreports.desktop 2>&1)
#if [ ! $? -eq 0 ];then
#	echo -en "Error:: No s'ha generat bé la icona de Jclic reports\n"
#fi

