#!/bin/bash
#
#       70 - Configure JClic reports
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo "[$date] Configuració JClic Reports"
echo "****************************************************"

. /etc/Linkat/linkat-server/Entorn_env

export pass=`cat $DIR_LINKAT/data/.passwd`
res_code=0

if [ $res_code -ne 0 ];then
	echo "Error:: S'ha produït un error al aplicar els canvis del servidor Mysql: $res"
else
	#sleep 5
	err_code=0
	existeix=0
	res=$(mysql -u root -p${pass} < $DIR_JCLIC/data/01_create_database.sql 2>&1)
	if [ ! $? -eq 0 ];then
		res=$(echo $res | grep -i "database exist" 2>&1)
		if [ ! $? -eq 0 ];then 
			echo "Error:: No s'ha pogut crear la base de dades JClicReports: $res"
			err_code=1
		else
			existeix=1
		fi
	fi


	if [ $err_code -eq 0 ];then
		res=$(mysql -u root -p${pass} JClicReports < $DIR_JCLIC/data/02_create_user_grants.sql 2>&1)
		if [ ! $? -eq 0 ];then
			echo "Error:: No s'han pogut establir els permisos de la base de dades JClicReports: $res"
			export pass=""
		else
			if [ $existeix -eq 0 ];then
				res=$(mysql -u jclic_user -pjclic_pwd JClicReports < $DIR_JCLIC/data/jclic_test_mysql.sql 2>&1)
				if [ ! $? -eq 0 ];then
					echo "S'han afegit les dades de test: $res"
					export pass=""
					err_code=1
				else
					echo -en "S'ha creat la base de dades JClicReports amb usuari: jclic_user \n"
					export pass=""
				fi
			fi
		fi
	fi
fi

# Configuració del connector

res=$(mkdir -m 777 -p /usr/java/packages/lib/ext 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut el directori-connector: $res\n"
fi

res=$(ln -s /usr/share/java/mysql-connector-java.jar /usr/java/packages/lib/ext/ 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut crear el link-connector: $res\n"
fi


res=$(mkdir -m 777 -p /usr/local/JClic 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut directori Reports: $res\n"
fi

res=$(chown -R tomcat7.tomcat7 /usr/share/tomcat7 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: No s'han pogut establir els permissos del directori del tomcat"
fi

res=$(cp $DIR_JCLIC/data/jclicReports.properties /usr/share/tomcat7/ 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: S'ha produit un error al copiar la configuració del servidor d'informes"
else
	res=$(chown tomcat7.tomcat7 /usr/share/tomcat7/jclicReports.properties 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produit un error al establir els permissos del fitxer de configuració del servidor d'informes: $res\n"
	fi
fi

chmod 644 /usr/share/tomcat7/jclicReports.properties

###
res=$(cp $DIR_JCLIC/data/jclicreports.war /var/lib/tomcat7/webapps/ 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produit un error al copiar jclicreports.war: $res\n"
fi

res=$(chown tomcat7.tomcat7 /var/lib/tomcat7/webapps/jclicreports.war 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produit un error al donar permisos jclicreports.war: $res\n"
fi

###
res=$(cp /etc/tomcat7/tomcat-users.xml $DIR_JCLIC/backup/tomcat-users.xml 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produit un error al fer backup de tomcat-users.xml: $res\n"
fi

res=$(cp $DIR_JCLIC/data/tomcat-users.xml /etc/tomcat7/tomcat-users.xml 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produit un error al crear l'usuari administrdor de Tomcat: $res \n"
else
	echo -en "Success: S'ha creat l'usuari administrador de Tomcat:\n\t\t usuari: linkat \n\t\t contrasenya: linkat \n\t per canviar la contrasenya editeu el fitxer /etc/tomcat7/tomcat-users.xml o des de l'administrador\n"
fi


