#!/bin/bash
echo -en  "\n*** 00-variables.sh \n"
. /etc/Linkat/linkat-server/serveis/LDAP/install/config-ldap

err=0

### Modificant l'script 02-populating-ldap.sh
cat $DATA/02-populating-ldap.sh.linkat | \
        sed s/__DOMINI__/$DOMINI/g | \
	sed s/__PASSWDLDAP__/$PASS_LDAP/g \
	> $INSTALL/02-populating-ldap.sh
if [ $? -gt 0 ]; then
        echo "Error:: No s'ha pogut mpdificar les variables de 02-populating-ldap.sh"
        err=1
else
	chmod 750 $INSTALL/02-populating-ldap.sh
        echo "Variables modificades a 02-populating-ldap.sh"
fi

chmod +x $INSTALL/02-populating-ldap.sh

### Modificant variables slapd ###
cat  $DATA/debconf.slapd.linkat | \
	sed s/__PASSWDLDAP__/$PASS_LDAP/g | \
	sed s/__DOMINI__/$DOMINI/g \
	> $DATA/debconf.slapd

if [ $? -gt 0 ]; then
        echo "Error:: No s'ha pogut substituir les variables"
        err=1
else
        echo "Succeed: Variables substituides"
fi

echo " sudo debconf-set-selections $DATA/debconf.slapd -->"

if [ $err -eq 0 ]; then
	sudo debconf-set-selections $DATA/debconf.slapd
	rm $DATA/debconf.slapd
fi


echo "Modificant variables ldap-auth-config"
cat  $DATA/debconf.ldap-auth-config.linkat | \
	sed s/__PASSWDLDAP__/$PASS_LDAP/g | \
	sed s/__NOM__/$NOM/g | \
	sed s/__DOMINI__/$DOMINI/g \
	> $DATA/debconf.ldap-auth-config

if [ $? -gt 0 ]; then
        echo "Error:: No s'ha pogut substituir les variables ldap-auth-config"
        err=1
else
        echo "Succeed: Variables substituides ldap-auth-config"
fi

if [ $err -eq 0 ]; then
	sudo debconf-set-selections $DATA/debconf.ldap-auth-config
        rm $DATA/debconf.ldap-auth-config

fi

## Modificant variables ldapconfig.ldif ###
cat  $DATA/ldapconfig.ldif.linkat | \
        sed s/__DOMINI__/$DOMINI/g \
        > $DATA/ldapconfig.ldif

if [ $? -gt 0 ]; then
        echo "Error:: No s'ha pogut substituir les variables a ldapconfig.ldif"
        err=1
else
        echo "Variables substituides a ldapconfig.ldif"
fi

## Modificant variables grups.ldif ###
cat  $DATA/grups.ldif.linkat | \
        sed s/__DOMINI__/$DOMINI/g \
        > $DATA/grups.ldif

if [ $? -gt 0 ]; then
        echo "Error: No s'ha pogut substituir les variables a grups.ldif"
        err=1
else
        echo "Succeed: Variables substituides a grups.ldif"
fi

### Modificant ldap.conf ### 
cat  $DATA/ldap.conf.linkat | \
	sed s/__NOM__/$NOM/g | \
        sed s/__DOMINI__/$DOMINI/g \
        > $DATA/ldap.conf
if [ $? -eq 0 ]; then
	mv $DATA/ldap.conf /etc/ldap/ldap.conf
else
        echo "Error:: No s'ha pogut modificat les variables de ldap.conf"
fi


if [ ! $err -eq 0 ]; then
	echo "Alguna cosa no ha anat correctament. Script 00" >> $LDAPLOG
else
        echo "Script 00. Tot correcte" >> $LDAPLOG
fi
