#!/bin/bash
#
#  3 - Configure default network parameters
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo "[$date] Configurant paràmetres de xarxa "
echo "        Deshabilitant el NetworkManager "
echo "****************************************************"

. /etc/Linkat/linkat-server/Entorn_env

. /etc/Linkat/linkat-server/.entornvarlinkat

if [ -e $DIR_NET/data/net_device ]; then
	DEV=`cat $DIR_NET/data/net_device`
else
	echo -en "Error:: No s'ha definit el dispositiu de xarxa.\n" 
	exit 1
fi


if [ -e /etc/network/interfaces ]; then
	res=$(cp /etc/network/interfaces $DIR_NET/backup/interfaces.orig 2>&1)
	if [ ! $? -eq 0 ];then
		echo -en "Error:: No s'ha pogut fer una còpia de seguretat de /etc/network/interfaces; $res \n"
	fi
fi


echo -en "Configurant interficies de xarxa \n" 
res=$(cp $DIR_NET/data/interfaces.Linkat /etc/network/interfaces)
if [ ! $? -eq 0 ];then
	echo -en "Error:: Hi ha hagut un error al aplicar la configuració d'interficies: $res\n"
else
	echo -en "Success: S'ha aplicat correctament el fitxer d'interficies\n"
fi


echo -en "Afegint interficie a /interfaces.d \n" 
res=$(cp $DIR_NET/data/$DEV.cfg  /etc/network/interfaces.d/)
if [ ! $? -eq 0 ];then
	echo -en "Error:: Hi ha hagut un error a l'aplicar la configuració predeterminada sobre la interficie de xarxa $DEV: $res\n"
else
	echo -en "Success: S'ha aplicat correctament el fitxer de la interficie de xarxa $DEV \n"
fi


ifdown $DEV && ifup $DEV


route add -net 0.0.0.0/0 gw $NEW_GATEWAY


## Verifiquem connexió
sleep 3
res=$(ping -c 2 www.google.es || ping -c 2 www.wikipedia.com || ping -c 2 www.linux.org 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: És necessari connexió a Internet per continuar \n"

${ZENITY} --title="Prova de connexió a Internet fallida" --error --text="És necessari connexió a Internet per continuar."

	echo "fail" > /etc/modalitat_linkat
	if [ ! $? -eq 0 ];then
		echo -en "Error creant la marca d'instal·lació \n"
	else
		echo -en "Ok, marca creada correctament \n"
	fi

else
	echo -en "Success: Connexió a internet correcte. \n"
fi

