#!/bin/bash
#
#       60 - Configure NFS server 
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Servidor NFS \n"
echo "****************************************************"

. /etc/Linkat/linkat-server/Entorn_env


res=$(cp /etc/exports $DIR_NFS/backup/exports.orig 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error: No s'ha pogut fer una còpia de seguretat de la configuració NFS: $res \n"
fi

res=$(cp /etc/default/nfs-kernel-server $DIR_NFS/backup/nfs-kernel-server.orig 2>&1)
if [ ! $? -eq 0 ];then
        echo -en "Error: No s'ha pogut fer una còpia de seguretat de la configuració NFS: $res \n"
fi

echo -en "S'està aplicant la configuració NFS de Linkat: \n"
res=$(cp -f $DIR_NFS/data/exports.Linkat /etc/exports 2>&1)
if [ ! $? -eq 0 ];then
		echo -en "Error:: S'ha produit un error aplicant la configuració del servidor NFS: $res \n"
	else
		echo -en "S'estan establint els permisos: "
		res=$(chmod 644 /etc/exports 2>&1)
		if [ ! $? -eq 0 ];then
			echo -en "Error:: No s'ha pogut establir permisos adients al fitxer de configuració del servidor NFS: $res \n"
		else
			echo -en "Ok\n"
		fi
fi

res=$(cp  $DIR_NFS/data/nfs-kernel-server.Linkat /etc/default/nfs-kernel-server 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: S'ha produit un error aplicant la configuració del servidor NFS: $res \n"
fi

echo "S'estan aplicant els canvis al servidor NFS: "
res=$(service nfs-kernel-server restart 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut reiniciar el servei nfs-kernel-serve: $res \n"
else
	echo -en "Ok\n"
fi

                
echo -en "S'està afegint el servidor NFS a la seqüència d'init:  \n"
res=$(update-rc.d nfs-kernel-server enable 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut posar el servei NFS a la seqüència d'init \n"
else
	echo -en "Success: Servidor NFS configurat correctament\n"
fi      


