#!/bin/bash
#
#       91 - Configure Owncloud
#

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Owncloud \n"
echo "****************************************************"

. /etc/Linkat/linkat-server/Entorn_env

. /etc/Linkat/linkat-server/.entornvarlinkat


echo a2enmod rewrite:
a2enmod rewrite 2>&1

echo a2enmod ssl:
a2enmod ssl 2>&1

echo a2enmod headers:
a2enmod headers 2>&1

mkdir -p /etc/apache2/ssl/  2>&1

res=$(cat $DIR_OWN/data/openssl.cnf.Linkat  | sed s/__DOMINI__/$DOMINI/g | sed s/__NOM__/$NOM/g > /etc/ssl/openssl.cnf 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: No s'ha pogut configurar OpenSSL: $res "
else
	echo "Succeed: S'ha configurat OpenSSL "
fi


#generem certificat

openssl req -new -x509 -days 36500 -nodes -out /etc/apache2/ssl/owncloud.pem -keyout /etc/apache2/ssl/owncloud.key

#export pass=root

export pass=`cat $DIR_LINKAT/data/.passwd`


#### Carreguem la BBDD#####


res=$(mysql --user=root -p$pass < $DIR_OWN/data/create_database_oc.sql 2>&1)
if [ ! $? -eq 0 ];then
	res=$(echo $res | grep -i "database exist" 2>&1)
	if [ ! $? -eq 0 ];then 
		echo "Error:: No s'ha pogut crear la base de dades owncloud: $res"
	else
		echo "Succeed: S'ha creat la BDD owncloud correctament "
	fi
fi


res=$(cat $DIR_OWN/data/permisos_oc.sql | mysql --user=root -p$pass 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No ha estat possible afegir la BBDD owncloud: $res \n"
else
	echo "Succeed: S'ha creat l'usuari owncloud "
fi


res=$( cat $DIR_OWN/data/owncloud_exp.sql.Linkat | sed s/__DOMINI__/$DOMINI/g | sed s/__NOM__/localhost/g > $DIR_OWN/data/owncloud_exp.sql 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No ha estat possible configurar la base de dades d'Owncloud: $res \n"
else
	echo "Succeed: S'ha configurat la base de dades d'Owncloud "
fi


res=$(mysql --user=owncloud --password=owncloud owncloud < $DIR_OWN/data/owncloud_exp.sql 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: No s'ha pogut exportat les dades d'owncloud: $res"
else
	echo "Succeed: S'han exportat les dades correctament "
fi

res=$(cp /etc/owncloud/htaccess $DIR_OWN/backup/htaccess 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error::  No s'ha pogut fer backup ../owncloud/htaccess: $res\n"
fi

res=$(cp $DIR_OWN/data/htaccess /etc/owncloud/htaccess 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error::  No s'ha pogut configurar ../owncloud/htaccess: $res\n"
fi

res=$(cp $DIR_OWN/data/config.php /etc/owncloud/config.php 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error::  No s'ha pogut configurar ../owncloud/config.php: $res\n"
fi


chown www-data:www-data -R /etc/owncloud/  2>&1

chown www-data:www-data -R /usr/share/owncloud/ 2>&1

chmod 0770 /usr/share/owncloud/ 2>&1

## Reiniciem el servei mysql.....

res=$(service mysql restart 2>&1)
if [ ! $? -eq 0 ];then	
	echo "Error:: No s'ha pogut reiniciar mysql: $res  "	
else
	echo "Succeed: Servei mysql reiniciat"
fi


#
res=$(cp /etc/apache2/apache2.conf $DIR_OWN/backup/apache2.conf 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut backup apache2.con: $res\n"
fi

res=$(cp /etc/apache2/ports.conf $DIR_OWN/backup/ports.conf 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut backup ports.conf: $res\n"
fi

res=$(cp $DIR_OWN/data/apache2.conf.Linkat /etc/apache2/apache2.conf 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut configurar apache2.conf: $res\n"
fi

res=$(cp $DIR_OWN/data/ports.conf.Linkat /etc/apache2/ports.conf 2>&1)
if [ ! $? -eq 0 ];then
	echo -en "Error:: No s'ha pogut configurar ports.conf: $res\n"
fi

res=$(cat $DIR_OWN/data/owncloud.conf.Linkat  | sed s/__DOMINI__/$DOMINI/g | sed s/__NOM__/$NOM/g > /etc/apache2/sites-enabled/owncloud.conf 2>&1)
if [ ! $? -eq 0 ];then
	echo "Error:: S'ha produit un error al copiar la configuració sites-enabled/owncloud.conf: $res  "
else
	echo "Succeed: S'ha configurat la zona d'owncloud"
fi


res=$(service apache2 restart 2>&1)
if [ ! $? -eq 0 ];then	
	echo "Error:: No s'ha pogut reiniciar apache2: $res "
else
	echo "Succeed: Servei apache2 reiniciat"
fi

res=$(cp $DIR_LINKAT/data/clau_owncloud.php /etc/owncloud/clau_owncloud.php 2>&1)
if [ ! $? -eq 0 ];then	
	echo "Error:: No s'ha pogut copiar /etc/owncloud/clau_owncloud.p: $res "
fi

res=$(cp $DIR_LINKAT/data/owncloud_pass.sh /etc/owncloud/owncloud_pass.sh 2>&1)
if [ ! $? -eq 0 ];then	
	echo "Error:: No s'ha pogut copiar /etc/owncloud/owncloud_pass.sh: $res "
fi

### icon 

cd "/home/lnadmin/Escriptori/Eines d'administració"
cp $DIR_OWN/data/owncloud-pass.desktop owncloud-pass.desktop
cp -p /usr/share/owncloud/core/img/favicon-touch.png /usr/share/favicon-touch.png

