#!/bin/bash

. /etc/Linkat/linkat-server/serveis/SAMBA/install/config-samba

err=0

killall update-manager update-notifier

sudo apt-get install -y samba samba-doc smbldap-tools
if [ ! $? -eq 0 ]; then
        echo -en "Error: No s'ha pogut instal·lar el paquet samba"
        err=1
else
        echo -en "Paquets instal·lats"
fi

sudo ldapadd -Q -Y EXTERNAL -H ldapi:/// -f $DATA/samba.ldif

sudo ldapmodify -Q -Y EXTERNAL -H ldapi:/// -f $DATA/samba_indices.ldif

GETLOCALSID=$(net getlocalsid | cut -d " " -f 6)

cat  $DATA/smbldap.conf.linkat | \
        sed s/__PASSWDLDAP__/$PASS_LDAP/g | \
        sed s/__NOM__/$NOM/g | \
	sed s/__DOMINI__/$DOMINI/g | \
	sed s/__GETLOCALSID__/$GETLOCALSID/g  \
        > $DATA/smbldap.conf
if [ ! $? -eq 0 ]; then
        echo -en "Error: No s'ha pogut substituir les variables de smbldap.conf.linkat"
        err=1
else
        echo -en "Variables substituides a smbldap.conf.linkat"
fi
 
cat  $DATA/smbldap_bind.conf.linkat | \
        sed s/__PASSWDLDAP__/$PASS_LDAP/g | \
        sed s/__DOMINI__/$DOMINI/g \
        > $DATA/smbldap_bind.conf
if [ ! $? -eq 0 ]; then
        echo -en "Error: No s'ha pogut substituir les variables a smbldap_bind.conf.linkat"
        err=1
else
        echo -en "Variables substituides a smbldap_bind.conf.linkat"
fi


sudo mv $DATA/smbldap*.conf /etc/smbldap-tools/
if [ ! $? -eq 0 ]; then
        echo -en "Error: No s'ha pogut copiar els smbldap*.conf"
        err=1
else
        echo -en "smbldap*.conf copiats a /etc/smbldap-tools/"
fi

sudo chmod 750 /etc/smbldap-tools/*
if [ $? -eq 0 ]; then
        echo -en "Modificats els permisos a /etc/smbldap-tools/"
else
        echo -en "Error: No s'ha pogut modificar els permisos de smbldap*.conf"
fi

cat  $DATA/02-smbldap-populate.sh.linkat | \
	sed s/__PASSWDLDAP__/$PASS_ROOT/g  \
	> $INSTALL/02-smbldap-populate.sh
chmod 750 $INSTALL/02-smbldap-populate.sh

cat  $DATA/smb.conf.linkat | \
        sed s/__SERVIDOR__/$NOM/g | \
        sed s/__NOM__/$NOM/g | \
	sed s/__DOMINI__/$DOMINI/g \
        > $DATA/smb.conf
if [ ! $? -eq 0 ]; then
        echo -en "Error: No s'ha pogut substituir les variables de smb.conf.linkat"
        err=1
else
        echo -en "Variables substituides a smb.conf.linkat"
fi

sudo mv $DATA/smb.conf /etc/samba/smb.conf
if [ ! $? -eq 0 ]; then
        echo -en "Error: No s'ha pogut copiar els smbl.conf"
        err=1
else
        echo -en "smb.conf copiats a /etc/samba/"
fi

if [ ! $err -eq 0 ]; then
        echo "Alguna cosa no ha anat correctament!" >> $SAMBALOG
else
        echo "Script 01. Tot correcte" >> $SAMBALOG
fi
