#!/bin/bash

date=`date +"%d/%m/%Y %H:%M"`
echo -en "\n\n****************************************************\n"
echo -en "[$date] Uninstall - Servidor Lnadmin \n"
echo "****************************************************"

. /etc/Linkat/linkat-server/.entornvarlinkat
. /etc/Linkat/linkat-server/Entorn_env

echo -e "\n\t# lnadmin privilege drop #\n"

echo -e "Revocant permisos d'escriptura a la unitat S"
res=$(setfacl -x u:lnadmin /srv/exports/S 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: Problemes revocant ACL a /srv/exports/S ; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: Permisos d'escriptura sobre la unitat S revocats satisfactòriament\n"
fi

echo -e "Revocant permisos d'escriptura a la unitat G"
res=$(setfacl -x u:lnadmin /srv/exports/G 2>&1)
if [ ! $? -eq 0 ];then
	echo -e "Error:: Problemes revocant ACL a /srv/exports/G ; $res"
else
	echo -e "Ok\n"
	echo -e "\n\tSuccess: Permisos d'escriptura sobre la unitat G revocats satisfactòriament\n"
fi

echo -e "Revocant permisos d'aminitració d'impressores\n"
res=$(rm /var/lib/polkit-1/localauthority/20-org.d/linkat.desktop.pkla 2>&1)
if [ $? -eq 0 ];then
        echo -e "\n\tSuccess: Permisos d'impressores revocats satisfactòriament\n"
else
	echo -e "Error:: Problemes revocant permisos d'impressores\n"
fi


echo -e "Revocant permisos d'administració a lnadmin"
if [ -e $DIR_LNADMIN/backup/sudoers.orig ];then
        echo -e "Restablint còpia de seguretat del sudoers original:"
        res=$(cp -f $DIR_LNADMIN/backup/sudoers.orig /etc/sudoers 2>&1)
        if [ ! $? -eq 0 ];then
		echo -e "\n\tError:: S'ha produït un error al restablir el backup del fitxer sudoers; $res"
	else
		echo -e "Ok\n"
	fi
else
	echo -e "\n\tWarning: No s'ha pogut restablir el fitxer sudoers original, es manté la configuració actual"
fi 
